/**********************************************************************
 *
 * browsetools.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: browsetools.h 404 1999-07-20 02:58:16Z sjboddie $
 *
 *********************************************************************/


#ifndef BROWSETOOLS_H
#define BROWSETOOLS_H

#include "gsdlconf.h"
#include "text_t.h"
#include "cgiargs.h"
#include "display.h"
#include "recptproto.h"


// Note that at present the build software is capable (if you write a plugin to do
// it) of generating classifications that contain other classifications of a 
// different type. This module can only handle one case of that however (i.e. an
// AZList containing a Hierarchy classification as used by hdl's 'magazine'
// section). It really needs redesigning to handle all cases.


void book_toc (cgiargsclass &args, recptproto *collectproto, 
	       displayclass &disp, outconvertclass &outconvert, 
	       ostream &textout, ostream &logout);

void hierarchy_toc (const text_t &classifytype, 
		    cgiargsclass &args, recptproto *collectproto, 
		    displayclass &disp, outconvertclass &outconvert, 
		    ostream &textout, ostream &logout);

void list_toc (const text_t &classifytype, text_t &formatstring, 
	       cgiargsclass &args, recptproto *collectproto, 
	       displayclass &disp, outconvertclass &outconvert, 
	       ostream &textout, ostream &logout);

void datelist_toc (const text_t &classifytype, const text_t &classifytitle, 
		   const text_t &formatstring, cgiargsclass &args, recptproto *collectproto, 
		   displayclass &disp, outconvertclass &outconvert, 
		   ostream &textout, ostream &logout);

void set_arrow_macros (const text_t &OID, const text_t &classifytype,
		       displayclass &disp, recptproto *collectproto, 
		       const text_t &collection, ostream &logout);


#endif
