/**********************************************************************
 *
 * documentaction.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: documentaction.h 399 1999-07-16 08:32:58Z rjmcnab $
 *
 *********************************************************************/


#ifndef DOCUMENTACTION_H
#define DOCUMENTACTION_H

#include "action.h"
#include "gsdlconf.h"

class documentaction : public action {

protected:
  virtual void output_document (const text_t &OID, cgiargsclass &args, 
				recptproto *collectproto, displayclass &disp, 
				outconvertclass &outconvert, ostream &textout, 
				ostream &logout);

  void highlighttext(text_t &text, TermInfo_tarray &terms, displayclass &disp,
		     outconvertclass &outconvert, ostream &textout, ostream &logout);


public:
  documentaction ();
  virtual ~documentaction ();

  bool init (ostream &logout);

  text_t get_action_name () {return "d";}

  bool check_cgiargs (cgiargsinfoclass &argsinfo, cgiargsclass &args, 
		      ostream &logout);

  void get_cgihead_info (cgiargsclass &args, response_t &response,
                         text_t &response_data, ostream &logout);

  void define_external_macros (displayclass &disp, cgiargsclass &args, 
			       recptproto *collectproto, ostream &logout);

  void define_internal_macros (displayclass &disp, cgiargsclass &args, 
			       recptproto *collectproto, ostream &logout);

  bool do_action (cgiargsclass &args, recptproto *collectproto,
                  displayclass &disp, outconvertclass &outconvert,
                  ostream &textout, ostream &logout);

};



#endif


