/**********************************************************************
 *
 * formattools.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: formattools.h 410 1999-07-21 05:00:00Z sjboddie $
 *
 *********************************************************************/


#ifndef FORMATTOOLS_H
#define FORMATTOOLS_H

#include "text_t.h"
#include "comtypes.h"

enum command_t {comIf, comOr, comMeta, comText, comLink, comEndLink, comNum, comIcon};
enum pcommand_t {pNone, pImmediate, pTop, pIndex, pAll};
enum dcommand_t {dMeta};

struct metadata_t {
  void clear();
  metadata_t () {clear();}

  text_t metaname;
  int metaindex;
  pcommand_t parentcommand;
  int parentindex;
  text_t parentoptions;
};

struct decision_t {
  void clear();
  decision_t () {clear();}

  dcommand_t command;
  metadata_t meta;
};

struct format_t {
  void clear();
  format_t () {clear();}

  command_t command;
  decision_t decision;
  text_t text;
  metadata_t meta;
  format_t *nextptr;
  format_t *ifptr;
  format_t *elseptr;
  format_t *orptr;
};



bool parse_formatstring (const text_t &formatstring, format_t *formatlistptr, 
			 text_tarray &metadata, bool &getParents);

text_t get_formatted_string (const ResultDocInfo_t &docinfo, format_t *formatlistptr,
			     const text_t &link, const text_t &icon);

text_t get_formatted_string (const ResultDocInfo_t &docinfo, format_t *formatlistptr);


#endif
