/**********************************************************************
 *
 * usersaction.h -- managing users
 * Copyright (C) 1999  DigiLib Systems Limited, New Zealand
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: usersaction.h 373 1999-07-13 23:22:05Z rjmcnab $
 *
 *********************************************************************/


#ifndef USERSACTION_H
#define USERSACTION_H

#include "gsdlconf.h"
#include "action.h"
#include "text_t.h"


class usersaction : public action {
protected:
  text_t usersfile;

public:
  usersaction ();
  virtual ~usersaction () {}

  void configure (const text_t &key, const text_tarray &cfgline);
  
  text_t get_action_name () {return "um";}
  
  bool check_cgiargs (cgiargsinfoclass &argsinfo, cgiargsclass &args, 
		      ostream &logout);

  void get_cgihead_info (cgiargsclass &args, response_t &response,
			 text_t &response_data, ostream &logout);
  
  void define_internal_macros (displayclass &disp, cgiargsclass &args, 
			       recptproto *collectproto, ostream &logout);
  void define_external_macros (displayclass &disp, cgiargsclass &args, 
			       recptproto *collectproto, ostream &logout);
  
  bool do_action (cgiargsclass &args, recptproto *collectproto,
		  displayclass &disp, outconvertclass &outconvert, 
		  ostream &textout, ostream &logout);

protected:
  void define_user_macros (cgiargsclass &args, displayclass &disp);
  
  bool do_listusers (cgiargsclass &args, recptproto *collectproto,
		     displayclass &disp, outconvertclass &outconvert, 
		     ostream &textout, ostream &logout);
  bool do_edituser (cgiargsclass &args, recptproto *collectproto,
		    displayclass &disp, outconvertclass &outconvert, 
		    ostream &textout, ostream &logout);
  bool do_deleteuser (cgiargsclass &args, recptproto *collectproto,
		      displayclass &disp, outconvertclass &outconvert, 
		      ostream &textout, ostream &logout);
  bool do_changepasswd (cgiargsclass &args, recptproto *collectproto,
			displayclass &disp, outconvertclass &outconvert, 
			ostream &textout, ostream &logout);
};


#endif
